from ase.all import *
from EMMA_ap import make_structures

ap=3.9
#Make a BaO block
A1=Atoms("Ba4O4",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
A1.set_scaled_positions([[0.,0.,0.5],[0.5,0.,0.5],[0.,0.5,0.5],[0.5,0.5,0.5],
                         [0.25,0.25,0.5],[0.75,0.25,0.5],[0.25,0.75,0.5],[0.75,0.75,0.5]])
#Make CaO block
A2=Atoms("Ca4O4",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
A2.set_scaled_positions([[0.,0.,0.5],[0.5,0.,0.5],[0.,0.5,0.5],[0.5,0.5,0.5],
                         [0.25,0.25,0.5],[0.75,0.25,0.5],[0.25,0.75,0.5],[0.75,0.75,0.5]])

#Make Y block
A3=Atoms("Y4",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
A3.set_scaled_positions([[0.,0.,0.5],[0.5,0.,0.5],[0.,0.5,0.5],[0.5,0.5,0.5]])

AMods=[A1,A2,A3]
nA=[2,4,2]

#Make FeO2 block
B1=Atoms("Fe4O8",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
B1.set_scaled_positions([[0.25,0.25,0.5],[0.75,0.25,0.5],[0.25,0.75,0.5],[0.75,0.75,0.5],
                         [0.25,0.,0.5],[0.25,0.5,0.5],[0.75,0.,0.5],[0.75,0.5,0.5],
                         [0.,0.25,0.5],[0.5,0.25,0.5],[0.,0.75,0.5],[0.5,0.75,0.5]])

#Make Fe3CuO8 block
B2=Atoms("CuFe3O8",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
B2.set_scaled_positions([[0.25,0.25,0.5],[0.75,0.25,0.5],[0.25,0.75,0.5],[0.75,0.75,0.5],
                         [0.25,0.,0.5],[0.25,0.5,0.5],[0.75,0.,0.5],[0.75,0.5,0.5],
                         [0.,0.25,0.5],[0.5,0.25,0.5],[0.,0.75,0.5],[0.5,0.75,0.5]])

#Make Fe3CuO8 block
B3=Atoms("Fe3CuO8",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
B3.set_scaled_positions([[0.25,0.25,0.5],[0.75,0.25,0.5],[0.25,0.75,0.5],[0.75,0.75,0.5],
                         [0.25,0.,0.5],[0.25,0.5,0.5],[0.75,0.,0.5],[0.75,0.5,0.5],
                         [0.,0.25,0.5],[0.5,0.25,0.5],[0.,0.75,0.5],[0.5,0.75,0.5]])

#Make Fe4O4 block
B4=Atoms("Fe4O4",cell=[2.*ap,2.*ap,0.5*ap],pbc=[1,1,1])
B4.set_scaled_positions([[0.25,0.25,0.5],[0.75,0.25,0.5],[0.25,0.75,0.5],[0.75,0.75,0.5],
                         [0.25,0.5,0.5],[0.75,0.,0.5],[0.,0.25,0.5],[0.5,0.75,0.5]])

BMods=[B1,B2,B3,B4]
nB=[5,1,1,1]

arrangements,structures=make_structures(AMods,BMods,nA,nB,write_format='Gulp',
                                        labelling='numeric',shells=["O","Ba","Ca"],rattle_dist=0.05)
view(structures)
